package main

import (
	"f5"
)

type App_ struct {
	f5.App_
}

var App = new (App_)

func (this *App_) Init() {
	f5.App = &this.App_
	f5.App.SetPkgName("admin")
	this.App_.Init()
	G.MetaMgr = new(MetaMgr).Init()
	G.HttpServer = new(f5.HttpServer).Init("httpserver", 1000 * 60)
	G.UserMgr = new(UserMgr).Init()
	G.DBEngine = new(DBEngine).Init()

	G.HttpServer.Start(G.MetaMgr.GetServer(1).GetListenPort());
}

func (this *App_) UnInit() {
	G.DBEngine.UnInit()
	G.UserMgr.UnInit()
	G.HttpServer.UnInit()
	G.MetaMgr.UnInit()
	this.App_.UnInit()
}

func (this *App_) RegisterAuthedHandler(
	pattern string,
	handle func(*f5.Context, *AuthedUser)) {
	G.HttpServer.RegisterRestHandle(pattern,
		func (c *f5.Context) {
			user := c.Get("user").(AuthedUser)
			handle(c, &user)
		})
}
