const ws = require("nodejs-websocket")
const app = require('j7/app');
const http = require('j7/http');
const utils = require('j7/utils');
const cmdHash = {};

let seqId = 0;
let conn = null;
let seqHash = {};

async function parsePackage(socket, data) {
  const msg = utils.jsonDecode(data);
  const context = seqHash[msg['seqId']];
  context['endTick'] = utils.getTickCount();
  console.log(context['endTick'] - context['beginTick']);
  context['session'].rspData(msg['data']);
}

async function test(session, params) {
  const currSeqId = ++seqId;
  const msg = {
    'url': 'https://login-z1-test.cebg.games/webapp/index.php',
    'params': {
      'c': 'Ops',
      'a': 'selfChecking'
    },
    'seqId': currSeqId,
    'payload': ''
  };
  seqHash[currSeqId] = {
    'seqId': currSeqId,
    'beginTick': utils.getTickCount(),
    'endTick': 0,
    'msg': msg,
    'session': session
  };
  const msgText = utils.jsonEncode(msg);
  const text = '#' + utils.pad(msgText.length, 7) + msgText;
  if (!conn) {
    conn = await ws.connect('ws://relation-z1-test.cebg.games/httpgate/websocket');
    conn.on('connect', () => {
      console.log('connect');
      conn.sendText(text);
    });

    let data = '';
    conn.on('text', (str) => {
      //console.log(str);
      data += str;
      //#0000000
      while (data.length >= 8) {
        if (data[0] != '#') {
          conn.close('error package');
          break;
        }
        const pkgLen = parseInt(data.slice(1, 8), 10);
        if (isNaN(pkgLen)) {
          conn.close('error pkgLen');
          break;
        }
        //console.log(data, pkgLen, data.slice(1,8));
        if (data.length >= 8 + pkgLen) {
          parsePackage(conn, data.slice(8, 8 + pkgLen));
          data = data.slice(8 + pkgLen);
          console.log(data);
        }
      }
    });

  }
  if (conn.readyState == conn.OPEN) {
    conn.sendText(text);
  }
  //session.rspOk();
}

async function execCmd(session) {
  const cmdLine = session.request('cmd').split('.');
  const cmd = cmdLine[0];
  const params = cmdLine.length > 1 ? cmdLine.slice(1) : [] ;
  if (cmdHash[cmd]) {
    cmdHash[cmd](session, params);
  } else {
    session.rspErr(404, 'not found');
  }
}

function init() {
  app.registerHandler('GM', 'execCmd', execCmd);
  cmdHash['test'] = test;
}

exports.init = init;
