package main

type Game interface {
	Init()
	UnInit()
	GetGameId() int32
}

type GameMgr struct {
	gameHash map[int32]Game
}

func (this *GameMgr) Init() *GameMgr {
	this.gameHash = make(map[int32]Game)
	this.gameHash[2005] = new(Game2005)

	for gameId, val := range(this.gameHash) {
		if (gameId != val.GetGameId()) {
			panic("GameMgr gameId error!")
		}
		val.Init()
	}
	return this
}

func (this *GameMgr) UnInit() {
	for _, val := range(this.gameHash) {
		val.UnInit()
	}
}
