package main

import (
	"q5"
	"f5"
)

type RankRule interface {
	Init()
	UnInit()
	RuleName() string
	IncrementUpdate()
	FullUpdate()
}

type RankMgr struct {
	ruleHash map[string] RankRule
}

func (this *RankMgr) Init() *RankMgr {
	rules := []RankRule{
		new(Game2001),
		new(Game2004),
		new(Game2005)}
	for _, val := range rules {
		if _, ok := this.ruleHash[val.RuleName()]; ok {
			panic("rulename already exists")
		}
		val.Init()
		this.ruleHash[val.RuleName()] = val
	}
	this.InstallTimer()
	return this
}

func (this *RankMgr) UnInit() {

}

func (this *RankMgr) InstallTimer() {
	for _, val := range G.MetaMgr.GetRankConfig() {
		f5.Timer().AddRepeatTimer(
			1000 * 60 * 5,
			func (params* q5.XParams) {

			},
			func (params* q5.XParams) {

			})
	}
}
