package main

import "mt"

type MtwServerInfo struct {
	*mt.ServerInfo
}

type MtwConf struct {
	*mt.Conf
	hearbeatHash map[int32]int32
}

func (this *MtwConf) Init() {
	this.hearbeatHash = make(map[int32]int32)
	for _, v := range this.GetGameHeartbeat() {
		this.hearbeatHash[v.GetGameid()] = v.GetHeartbeat()
	}
}

func (this *MtwConf) GetHeartBeatTimeout(gameid int32) int32 {
	if time, ok := this.hearbeatHash[gameid]; ok {
		return (time + this.GetNetDelay()) * 1000
	} else {
		return (60 * 5 + this.GetNetDelay()) * 1000
	}
}
